unit MainDlg;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, OpenNETCF.Desktop.Communication;

type
  TMainForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    TabControl: System.Windows.Forms.TabControl;
    AutostartTabPage: System.Windows.Forms.TabPage;
    FileTabPage: System.Windows.Forms.TabPage;
    BeerTabPage: System.Windows.Forms.TabPage;
    AddButton: System.Windows.Forms.Button;
    RemoveButton: System.Windows.Forms.Button;
    StatusTextBox: System.Windows.Forms.TextBox;
    InstallButton: System.Windows.Forms.Button;
    RunButton: System.Windows.Forms.Button;
    KillButton: System.Windows.Forms.Button;
    GetDataButton: System.Windows.Forms.Button;
    SendDataButton: System.Windows.Forms.Button;
    DataRichTextBox: System.Windows.Forms.RichTextBox;
    PowerTabPage: System.Windows.Forms.TabPage;
    PowerButton: System.Windows.Forms.Button;
    PowerTextBox: System.Windows.Forms.TextBox;
    FileStatusLabel: System.Windows.Forms.Label;
    SystemFoldersTabPage: System.Windows.Forms.TabPage;
    FoldersButton: System.Windows.Forms.Button;
    FoldersTextBox: System.Windows.Forms.TextBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure AddButton_Click(sender: System.Object; e: System.EventArgs);
    procedure RemoveButton_Click(sender: System.Object; e: System.EventArgs);
    procedure InstallButton_Click(sender: System.Object; e: System.EventArgs);
    procedure RunButton_Click(sender: System.Object; e: System.EventArgs);
    procedure KillButton_Click(sender: System.Object; e: System.EventArgs);
    procedure GetDataButton_Click(sender: System.Object; e: System.EventArgs);
    procedure SendDataButton_Click(sender: System.Object; e: System.EventArgs);
    procedure PowerButton_Click(sender: System.Object; e: System.EventArgs);
    procedure FoldersButton_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    FRapi : RAPI;

    procedure UpdateConnectionStatus(const StatusMessage : string);
    procedure UpdateFileStatus(const StatusMessage : string);
    procedure CheckIfDevicePresent;
    procedure ActiveSyncActive;
    procedure ActiveSyncDisconnect;
    procedure ActiveSyncListen;
    procedure ActiveSyncAnswer;
    function  InAutoStartList : Boolean;
    procedure UpdateAutostartStatus;
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TMainForm))]

implementation

uses
  System.IO;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TMainForm.InitializeComponent;
begin
  Self.TabControl := System.Windows.Forms.TabControl.Create;
  Self.AutostartTabPage := System.Windows.Forms.TabPage.Create;
  Self.StatusTextBox := System.Windows.Forms.TextBox.Create;
  Self.RemoveButton := System.Windows.Forms.Button.Create;
  Self.AddButton := System.Windows.Forms.Button.Create;
  Self.PowerTabPage := System.Windows.Forms.TabPage.Create;
  Self.PowerTextBox := System.Windows.Forms.TextBox.Create;
  Self.PowerButton := System.Windows.Forms.Button.Create;
  Self.FileTabPage := System.Windows.Forms.TabPage.Create;
  Self.KillButton := System.Windows.Forms.Button.Create;
  Self.RunButton := System.Windows.Forms.Button.Create;
  Self.InstallButton := System.Windows.Forms.Button.Create;
  Self.BeerTabPage := System.Windows.Forms.TabPage.Create;
  Self.DataRichTextBox := System.Windows.Forms.RichTextBox.Create;
  Self.SendDataButton := System.Windows.Forms.Button.Create;
  Self.GetDataButton := System.Windows.Forms.Button.Create;
  Self.SystemFoldersTabPage := System.Windows.Forms.TabPage.Create;
  Self.FoldersButton := System.Windows.Forms.Button.Create;
  Self.FileStatusLabel := System.Windows.Forms.Label.Create;
  Self.FoldersTextBox := System.Windows.Forms.TextBox.Create;
  Self.TabControl.SuspendLayout;
  Self.AutostartTabPage.SuspendLayout;
  Self.PowerTabPage.SuspendLayout;
  Self.FileTabPage.SuspendLayout;
  Self.BeerTabPage.SuspendLayout;
  Self.SystemFoldersTabPage.SuspendLayout;
  Self.SuspendLayout;
  // 
  // TabControl
  // 
  Self.TabControl.Anchor := (System.Windows.Forms.AnchorStyles(((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Left) or System.Windows.Forms.AnchorStyles.Right)));
  Self.TabControl.Controls.Add(Self.AutostartTabPage);
  Self.TabControl.Controls.Add(Self.FileTabPage);
  Self.TabControl.Controls.Add(Self.BeerTabPage);
  Self.TabControl.Controls.Add(Self.PowerTabPage);
  Self.TabControl.Controls.Add(Self.SystemFoldersTabPage);
  Self.TabControl.Location := System.Drawing.Point.Create(0, 0);
  Self.TabControl.Name := 'TabControl';
  Self.TabControl.SelectedIndex := 0;
  Self.TabControl.Size := System.Drawing.Size.Create(744, 432);
  Self.TabControl.TabIndex := 0;
  // 
  // AutostartTabPage
  // 
  Self.AutostartTabPage.Controls.Add(Self.StatusTextBox);
  Self.AutostartTabPage.Controls.Add(Self.RemoveButton);
  Self.AutostartTabPage.Controls.Add(Self.AddButton);
  Self.AutostartTabPage.Location := System.Drawing.Point.Create(4, 29);
  Self.AutostartTabPage.Name := 'AutostartTabPage';
  Self.AutostartTabPage.Size := System.Drawing.Size.Create(736, 399);
  Self.AutostartTabPage.TabIndex := 0;
  Self.AutostartTabPage.Text := 'Autostart';
  // 
  // StatusTextBox
  // 
  Self.StatusTextBox.Location := System.Drawing.Point.Create(16, 104);
  Self.StatusTextBox.Multiline := True;
  Self.StatusTextBox.Name := 'StatusTextBox';
  Self.StatusTextBox.ScrollBars := System.Windows.Forms.ScrollBars.Both;
  Self.StatusTextBox.Size := System.Drawing.Size.Create(712, 368);
  Self.StatusTextBox.TabIndex := 2;
  Self.StatusTextBox.Text := '';
  // 
  // RemoveButton
  // 
  Self.RemoveButton.Location := System.Drawing.Point.Create(16, 64);
  Self.RemoveButton.Name := 'RemoveButton';
  Self.RemoveButton.Size := System.Drawing.Size.Create(216, 23);
  Self.RemoveButton.TabIndex := 1;
  Self.RemoveButton.Text := 'Remove from autostart list';
  Include(Self.RemoveButton.Click, Self.RemoveButton_Click);
  // 
  // AddButton
  // 
  Self.AddButton.Location := System.Drawing.Point.Create(16, 24);
  Self.AddButton.Name := 'AddButton';
  Self.AddButton.Size := System.Drawing.Size.Create(216, 23);
  Self.AddButton.TabIndex := 0;
  Self.AddButton.Text := 'Add to autostart list';
  Include(Self.AddButton.Click, Self.AddButton_Click);
  // 
  // PowerTabPage
  // 
  Self.PowerTabPage.Controls.Add(Self.PowerTextBox);
  Self.PowerTabPage.Controls.Add(Self.PowerButton);
  Self.PowerTabPage.Location := System.Drawing.Point.Create(4, 29);
  Self.PowerTabPage.Name := 'PowerTabPage';
  Self.PowerTabPage.Size := System.Drawing.Size.Create(736, 399);
  Self.PowerTabPage.TabIndex := 3;
  Self.PowerTabPage.Text := 'Power';
  // 
  // PowerTextBox
  // 
  Self.PowerTextBox.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.PowerTextBox.Location := System.Drawing.Point.Create(16, 56);
  Self.PowerTextBox.Multiline := True;
  Self.PowerTextBox.Name := 'PowerTextBox';
  Self.PowerTextBox.ScrollBars := System.Windows.Forms.ScrollBars.Both;
  Self.PowerTextBox.Size := System.Drawing.Size.Create(704, 128);
  Self.PowerTextBox.TabIndex := 1;
  Self.PowerTextBox.Text := '';
  // 
  // PowerButton
  // 
  Self.PowerButton.Location := System.Drawing.Point.Create(16, 16);
  Self.PowerButton.Name := 'PowerButton';
  Self.PowerButton.Size := System.Drawing.Size.Create(160, 23);
  Self.PowerButton.TabIndex := 0;
  Self.PowerButton.Text := 'Get power status';
  Include(Self.PowerButton.Click, Self.PowerButton_Click);
  // 
  // FileTabPage
  // 
  Self.FileTabPage.Controls.Add(Self.KillButton);
  Self.FileTabPage.Controls.Add(Self.RunButton);
  Self.FileTabPage.Controls.Add(Self.InstallButton);
  Self.FileTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.FileTabPage.Name := 'FileTabPage';
  Self.FileTabPage.Size := System.Drawing.Size.Create(736, 406);
  Self.FileTabPage.TabIndex := 1;
  Self.FileTabPage.Text := 'File';
  // 
  // KillButton
  // 
  Self.KillButton.Location := System.Drawing.Point.Create(40, 96);
  Self.KillButton.Name := 'KillButton';
  Self.KillButton.Size := System.Drawing.Size.Create(208, 23);
  Self.KillButton.TabIndex := 2;
  Self.KillButton.Text := 'Kill BeerTaster on device';
  Include(Self.KillButton.Click, Self.KillButton_Click);
  // 
  // RunButton
  // 
  Self.RunButton.Location := System.Drawing.Point.Create(40, 64);
  Self.RunButton.Name := 'RunButton';
  Self.RunButton.Size := System.Drawing.Size.Create(208, 23);
  Self.RunButton.TabIndex := 1;
  Self.RunButton.Text := 'Run BeerTaster on device';
  Include(Self.RunButton.Click, Self.RunButton_Click);
  // 
  // InstallButton
  // 
  Self.InstallButton.AccessibleDescription := '';
  Self.InstallButton.Location := System.Drawing.Point.Create(40, 32);
  Self.InstallButton.Name := 'InstallButton';
  Self.InstallButton.Size := System.Drawing.Size.Create(208, 23);
  Self.InstallButton.TabIndex := 0;
  Self.InstallButton.Text := 'Install files';
  Include(Self.InstallButton.Click, Self.InstallButton_Click);
  // 
  // BeerTabPage
  // 
  Self.BeerTabPage.Controls.Add(Self.DataRichTextBox);
  Self.BeerTabPage.Controls.Add(Self.SendDataButton);
  Self.BeerTabPage.Controls.Add(Self.GetDataButton);
  Self.BeerTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.BeerTabPage.Name := 'BeerTabPage';
  Self.BeerTabPage.Size := System.Drawing.Size.Create(736, 406);
  Self.BeerTabPage.TabIndex := 2;
  Self.BeerTabPage.Text := 'Beer';
  // 
  // DataRichTextBox
  // 
  Self.DataRichTextBox.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.DataRichTextBox.Location := System.Drawing.Point.Create(168, 16);
  Self.DataRichTextBox.Name := 'DataRichTextBox';
  Self.DataRichTextBox.Size := System.Drawing.Size.Create(560, 383);
  Self.DataRichTextBox.TabIndex := 3;
  Self.DataRichTextBox.Text := '';
  // 
  // SendDataButton
  // 
  Self.SendDataButton.Location := System.Drawing.Point.Create(16, 56);
  Self.SendDataButton.Name := 'SendDataButton';
  Self.SendDataButton.Size := System.Drawing.Size.Create(136, 23);
  Self.SendDataButton.TabIndex := 1;
  Self.SendDataButton.Text := 'Send beer data';
  Include(Self.SendDataButton.Click, Self.SendDataButton_Click);
  // 
  // GetDataButton
  // 
  Self.GetDataButton.Location := System.Drawing.Point.Create(16, 16);
  Self.GetDataButton.Name := 'GetDataButton';
  Self.GetDataButton.Size := System.Drawing.Size.Create(136, 23);
  Self.GetDataButton.TabIndex := 0;
  Self.GetDataButton.Text := 'Get beer data';
  Include(Self.GetDataButton.Click, Self.GetDataButton_Click);
  // 
  // SystemFoldersTabPage
  // 
  Self.SystemFoldersTabPage.Controls.Add(Self.FoldersTextBox);
  Self.SystemFoldersTabPage.Controls.Add(Self.FoldersButton);
  Self.SystemFoldersTabPage.Location := System.Drawing.Point.Create(4, 29);
  Self.SystemFoldersTabPage.Name := 'SystemFoldersTabPage';
  Self.SystemFoldersTabPage.Size := System.Drawing.Size.Create(736, 399);
  Self.SystemFoldersTabPage.TabIndex := 4;
  Self.SystemFoldersTabPage.Text := 'System Folders';
  // 
  // FoldersButton
  // 
  Self.FoldersButton.Location := System.Drawing.Point.Create(16, 16);
  Self.FoldersButton.Name := 'FoldersButton';
  Self.FoldersButton.Size := System.Drawing.Size.Create(152, 23);
  Self.FoldersButton.TabIndex := 0;
  Self.FoldersButton.Text := 'Get system folders';
  Include(Self.FoldersButton.Click, Self.FoldersButton_Click);
  // 
  // FileStatusLabel
  // 
  Self.FileStatusLabel.AutoSize := True;
  Self.FileStatusLabel.Location := System.Drawing.Point.Create(8, 440);
  Self.FileStatusLabel.Name := 'FileStatusLabel';
  Self.FileStatusLabel.Size := System.Drawing.Size.Create(75, 22);
  Self.FileStatusLabel.TabIndex := 1;
  Self.FileStatusLabel.Text := 'Waiting...';
  // 
  // FoldersTextBox
  // 
  Self.FoldersTextBox.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.FoldersTextBox.Location := System.Drawing.Point.Create(16, 56);
  Self.FoldersTextBox.Multiline := True;
  Self.FoldersTextBox.Name := 'FoldersTextBox';
  Self.FoldersTextBox.ScrollBars := System.Windows.Forms.ScrollBars.Both;
  Self.FoldersTextBox.Size := System.Drawing.Size.Create(704, 312);
  Self.FoldersTextBox.TabIndex := 1;
  Self.FoldersTextBox.Text := '';
  // 
  // TMainForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(8, 19);
  Self.ClientSize := System.Drawing.Size.Create(744, 470);
  Self.Controls.Add(Self.FileStatusLabel);
  Self.Controls.Add(Self.TabControl);
  Self.Font := System.Drawing.Font.Create('Microsoft Sans Serif', 12, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.Name := 'TMainForm';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := '.NET RAPI Demo';
  Self.TabControl.ResumeLayout(False);
  Self.AutostartTabPage.ResumeLayout(False);
  Self.PowerTabPage.ResumeLayout(False);
  Self.FileTabPage.ResumeLayout(False);
  Self.BeerTabPage.ResumeLayout(False);
  Self.SystemFoldersTabPage.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TMainForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TMainForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  FRapi := RAPI.Create;
  Include(FRapi.ActiveSync.Active,ActiveSyncActive);
  Include(FRapi.ActiveSync.Disconnect,ActiveSyncDisconnect);
  Include(FRapi.ActiveSync.Listen,ActiveSyncListen);
  Include(FRapi.ActiveSync.Answer,ActiveSyncAnswer);
  CheckIfDevicePresent;
  UpdateAutostartStatus;
end;

procedure TMainForm.UpdateConnectionStatus(const StatusMessage : string);
begin
  StatusTextBox.AppendText(StatusMessage + #13#10);
end;

procedure TMainForm.UpdateFileStatus(const StatusMessage : string);
begin
  FileStatusLabel.Text := StatusMessage;
end;

procedure TMainForm.CheckIfDevicePresent;
begin
  if FRapi.DevicePresent then begin
    UpdateConnectionStatus('Device present');
  end else begin
    UpdateConnectionStatus('Device not present');
  end;
end;

procedure TMainForm.ActiveSyncActive;
begin
  UpdateConnectionStatus('Active');
end;

procedure TMainForm.ActiveSyncDisconnect;
begin
  UpdateConnectionStatus('Disconnected');
end;

procedure TMainForm.ActiveSyncListen;
begin
  UpdateConnectionStatus('Listening');
end;

procedure TMainForm.ActiveSyncAnswer;
begin
  UpdateConnectionStatus('Answering...');
end;

function TMainForm.InAutoStartList : Boolean;
  var
    App : string;
begin
  for app in FRapi.ActiveSync.AutoStartOnConnect do begin
    if (app = Application.ExecutablePath) then begin
      // Already added this application to the auto start application list
      Result := True;
      Exit;
    end;
  end;

  Result := False;
end;

procedure TMainForm.UpdateAutostartStatus;
begin
  if InAutoStartList then begin
    UpdateConnectionStatus('In autostart list');
  end else begin
    UpdateConnectionStatus('Not in autostart list');
  end;
end;

procedure TMainForm.AddButton_Click(sender: System.Object; e: System.EventArgs);
begin
  // Shouldn't really do this more than once, since as many instances
  // will start as you add
  if not InAutoStartList then begin
    FRapi.ActiveSync.AutoStartOnConnect.Add(Application.ExecutablePath);
    UpdateAutostartStatus;
  end;
end;

procedure TMainForm.RemoveButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.ActiveSync.AutoStartOnConnect.Remove(Application.ExecutablePath);
  UpdateAutostartStatus;
end;

procedure TMainForm.InstallButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.Connect();

  try
    // Cannot create a directory if it already exists
    // Note existence or not of trailing backslash - this is essential to get right!
    if not FRapi.DeviceFileExists('\Program Files\BeerTaster\') then begin
      FRapi.CreateDeviceDirectory('\Program Files\BeerTaster');
    end;

    FRapi.CopyFileToDevice('C:\Conferences\SDN\2005 Sept\Source\BeerTaster\bin\Debug\BeerTaster.exe',
                           '\Program Files\BeerTaster\BeerTaster.exe',True);
    FRapi.CopyFileToDevice('C:\Conferences\SDN\2005 Sept\Source\AppKiller\bin\Debug\AppKiller.exe',
                           '\Program Files\BeerTaster\AppKiller.exe',True);

    // Cannot create a shortcut if it already exists
    if not FRapi.DeviceFileExists('\Windows\Start Menu\BeerTaster.lnk') then begin
      FRapi.CreateDeviceShortcut('BeerTaster','\Program Files\BeerTaster\BeerTaster.exe');
    end;

    UpdateFileStatus('Copied files');
  finally
    FRapi.Disconnect;
  end;
end;

procedure TMainForm.RunButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.Connect();

  try
    FRapi.CreateProcess('\Program Files\BeerTaster\BeerTaster.exe','');
    UpdateFileStatus('Started BeerTaster');
  finally
    FRapi.Disconnect;
  end;
end;

procedure TMainForm.KillButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.Connect();

  try
    FRapi.CreateProcess('\Program Files\BeerTaster\AppKiller.exe','BeerTaster.exe');
    UpdateFileStatus('Stopped BeerTaster');
  finally
    FRapi.Disconnect;
  end;
end;

procedure TMainForm.GetDataButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.Connect();

  try
    // Make sure application on device is closed so latest data is saved
    FRapi.CreateProcess('\Program Files\BeerTaster\AppKiller.exe','BeerTaster.exe');
    UpdateFileStatus('Stopped BeerTaster');
    FRapi.CopyFileFromDevice(Path.GetDirectoryName(Application.ExecutablePath) +
                             '\BeerData.xml',
                             '\Program Files\BeerTaster\BeerData.xml',True);
    UpdateFileStatus('Copied data file from device');

    DataRichTextBox.LoadFile(Path.GetDirectoryName(Application.ExecutablePath) +
                             '\BeerData.xml',RichTextBoxStreamType.PlainText);
    UpdateFileStatus('Loaded beer data from device');
  finally
    FRapi.Disconnect;
  end;
end;

procedure TMainForm.SendDataButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.Connect();

  try
    // Could make sure app is stopped on device here
    DataRichTextBox.SaveFile(Path.GetDirectoryName(Application.ExecutablePath) +
                             '\BeerData.xml',RichTextBoxSTreamType.PlainText);
    FRapi.CopyFileToDevice(Path.GetDirectoryName(Application.ExecutablePath) +
                           '\BeerData.xml',
                           '\Program Files\BeerTaster\BeerData.xml',True);
    UpdateFileStatus('Sent beer data to device');
  finally
    FRapi.Disconnect;
  end;
end;

procedure TMainForm.PowerButton_Click(sender: System.Object; e: System.EventArgs);
  var
    PowerStatus : SYSTEM_POWER_STATUS_EX;
begin
  FRapi.Connect();

  try
    FRapi.GetDeviceSystemPowerStatus(PowerStatus);
    PowerTextBox.Text := '';
    PowerTextBox.AppendText('Main battery remaining : ' +
                            PowerStatus.BatteryLifePercent.ToString +
                            '%'#13#10);
    PowerTextBox.AppendText('Backup battery remaining : ' +
                            PowerStatus.BackupBatteryLifePercent.ToString +
                            '%');
  finally
    FRapi.Disconnect;
  end;
end;

procedure TMainForm.FoldersButton_Click(sender: System.Object; e: System.EventArgs);
begin
  FRapi.Connect();

  try
    FoldersTextBox.AppendText('Personal: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.Personal) + #13#10);
    FoldersTextBox.AppendText('Programs: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.Programs) + #13#10);
    FoldersTextBox.AppendText('Favorites: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.Favorites) + #13#10);
    FoldersTextBox.AppendText('StartUp: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.StartUp) + #13#10);
    // These two don't work
//    FoldersTextBox.AppendText('Recent: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.Recent) + #13#10);
//    FoldersTextBox.AppendText('Desktop: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.Desktop) + #13#10);
    FoldersTextBox.AppendText('Fonts: ' + FRapi.GetDeviceSystemFolderPath(SystemFolders.Fonts) + #13#10);
  finally
    FRapi.Disconnect;
  end;
end;


end.
